local entity = {}
local spdTbl = {}
bubData = {}
bubDataC = {}
local itemsList = {}
local c, d = 0, 0


--[[
if something is a table then initiation should be as: {}
if number or text then [nil]

entity becomes a ghost if it doesn't exist in [spdTbl] and:
	entity.is_visible = false
	entity.is_walkable = true
	entity.node.entity = nil
	
entity is dead if all above and:
	entity.node = nil

have to change it so ghost state WILL be in [spdTbl]
	]]

entity	=	{
			autoPickCh	= 100,		-- [num] <0, 100> auto pickup chance
			desc		= nil,		-- [str] description
			fov			=	{
							entity	= {},		-- [tbl] visible entities pointers, distance, ... eg: (node, 3, node, 3, node, 12,...)
							item	= {},		-- [tbl] visible items pointers, distance, ...
							node	= {}		-- [tbl] visuble nodes pointers, distance, ...
							},
			graphic		= nil,		-- [num] number of quad (17, 18 for monsters, 21 for player)
			id			= nil,		-- [num] position in entity's table (player is always 1st, so its ID = 1)
			is_visible	= false,	-- [bln]
			is_walkable	= false,	-- [bln]
			info		= nil,		-- [str] boss, ghost, monster, player
			item		= {},		-- [tbl] items pointers (monsters always 1 item)
			move		=	{
							node	= nil,	-- [tbl] node pointer
							g		= nil,	-- [num] movement cost (10 - horiz, 14 - diag), if entity stays in place than [move.g] = [entity.spd] so its [move.t] = 1
							dx		= 0,	-- [num] from <-1, 1> it is ONLY used to determine direction of movement and facing
							dy		= 0,	-- [num] as above
							t		= 1		-- [num] movement time: [entity.move.g] / [entity.spd] but 1st move is always in place so 1 is shorter
							},
			node		= nil,		-- [tbl] present node pointer
			path		= {},		-- [tbl] nodes pointers
			picture		= nil,		-- [str] name of face picture
			range		= nil,		-- [num] range of sight
			spd			= nil,		-- [num]
			timer		= 0,		-- [num] total timer of this entity ([move.t] is a timer for one move only)
			visited		= {},		-- [tbl] visited nodes pointers
			xT			= nil,
			yT			= nil
			}



entity.autoPick = function(this)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local random = math.random
	local aNd = this.node

	if #aNd.item > 0 and this.autoPickCh >= random(1, 100) then

		local aIt = aNd.item[1]
		aIt.entity = this
		aIt.is_visible = false
		aIt.node = nil

		if this.id == 1 then
			
			this.item[#this.item + 1] = aIt
			playSound("takeItem")
			this.range = this.range + 1

			if hint.key == 1 then
				bubData	=	{
							(entity[1].node.x - 1) * node.size + node.size / 2, (entity[1].node.y - 1) * node.size + node.size / 2,
							"Everytime I get a key\nmy FOV gets bigger\n(and vice versa)", font.cooper[16], "t",
							white, black
							}
				hint.key = 0
			end
			
			spell.spellUpdateList()
			
			if #this.item >= level and not is_hunting then entity.makeBoss() end
			
		elseif #this.item == 0 then
	
			this.autoPickCh = 0
			this.item = {aNd.item[1]}
			this.graphic = 17
			this.path = {}			-- also [entity.path] must be emptied

		end
		aNd.item = {}
		fov.generate(this)
	end
end



entity.makeBoss = function()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local random = math.random
	local aNd
	repeat aNd = nodeFloor[random(#nodeFloor)] until not aNd.entity
	local last = #entity + 1
	entity[last] = entity:new(
							{
							autoPickCh	= 0,
							desc		= "we need to talk",
							fov			=	{
											entity	= {},
											item	= {},
											node	= {}
											},
							graphic 	= 22,
							id			= last,
							info		= "boss",
							item		= {"dummy"},	-- it's not a pointer but it works - boss will never follow player
							node		= aNd,
							picture		= picture[random(3,5)],
							range		= random(5, 10),
							spd			= random(5, 20),
							timer		= spdTbl[last - 1].timer,
							visited		= {},
							xT			= (aNd.x - 1) * node.size,
							yT			= (aNd.y - 1) * node.size
							}
							)

	entity[last]:nxtMove()
	aNd.entity = entity[last]
	entity[last]:updSpdTbl(false)
	is_hunting = true
	playSound("exitShowUp")
	bubData	=	{
				(entity[1].node.x - 1) * node.size + node.size / 2, (entity[1].node.y - 1) * node.size + node.size / 2,
				"now, let's look\nfor the boss", font.cooper[16], "t",
				white, black
				}
end



entity.new = function(this, params)
--=================================================================================================================================
	return setmetatable(params or {}, {__index = this})
end



entity.putOnMap = function(this, keys, nodeFloorLocal, itemsOnGround)
--=================================================================================================================================
	spdTbl = {}
	local random = math.random
	local FS = node.size
	
	for i = 1, MON_NO + 1 do
		local rnd = random(#nodeFloorLocal)
		local aNd = nodeFloorLocal[rnd]

		if i == 1 then
			this[i]	= entity:new(
								{
								autoPickCh	= 100,
								desc		= "",
								fov			=	{
												entity	= {},
												item	= {},
												node	= {}
												},
								graphic		= 25,
								id			= 1,
								is_visible	= true,
								is_walkable	= false,
								info		= "player",
								item		= {},
								move		=	{
												node	= aNd,
												g		= 10,		-- this is not good: it should be entity.spd but it's not yet declared
												dx		= 0,
												dy		= 0,
												t		= 1
												},
								node		= aNd,
								path		= {},
								picture		= picture[1],
								range		= 5,
								spd			= 10,
								timer		= 0,
								visited		= {},
								xT			= (aNd.x - 1) * FS,
								yT			= (aNd.y - 1) * FS
								}
								)
		else
			this[i] = entity:new(
								{
								autoPickCh	= random(50, 100),
								desc		= "",
								fov			=	{
												entity	= {},
												item	= {},
												node	= {}
												},
								graphic 	= 18,
								id			= i,
								info		= "monster",
								item		= {},
								move		= {},
								node		= aNd,
								picture		= picture[random(3,5)],
								range		= random(5, 10),
								spd			= random(5, 20),
								visited		= {},
								xT			= (aNd.x - 1) * FS,
								yT			= (aNd.y - 1) * FS
								}
								)
			this[i]:nxtMove()
		end

		aNd.entity = this[i]
		table.remove(nodeFloorLocal, rnd)
		this[i]:updSpdTbl(false)
		
	end
	
	entity.moveMake()	-- so [spdTbl] will start with player
	
	for i = 1, #entity do
		fov.generate(entity[i])
	end
	
	return keys, nodeFloorLocal, itemsOnGround
end



entity.updSpdTbl = function(this, can_remove)
--[[===============================================================================================================================
	if [can_remove] then removes 1st entry from [spdTbl] - that is standard procedure since each monster taht just made a move is at 1st position and must be removed before putting it back to avoid repetitions of entities inside [spdTbl]
	[can_remove = false] is only used when building up new [spdTbl]
---------------------------------------------------------------------------------------------------------------------------------]]
	if can_remove then table.remove(spdTbl, 1) end

	this.timer = this.timer + this.move.t
	for i = 1, #spdTbl do
		if this.timer < spdTbl[i].timer then
			table.insert(spdTbl, i, this)
			return
		end
	end
	spdTbl[#spdTbl + 1] = this
end



entity.moveMake = function()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	while gs == "play" do
		local aEn = spdTbl[1]
		local aNd = aEn.node
		local nNd = aEn.move.node
		local plr = entity[1]

		if aEn.info ~= "ghost" then
			aEn.node = aEn.move.node
			aNd.entity = nil
			nNd.entity = aEn
			aEn:autoPick()
		else
			aEn.node = aEn.move.node
		end
			
--==== THIS IS END OF MOVE, FROM HERE NEXT ONE IS BEING GENERATED ====================
			
		if aEn == plr then 
			-- playSound("walk")
			break
		end
		
		-- path can only be calculated when planning next move
		-- attack can only be done instead of next move
		-- checkFovData(entity) will accept entity as visible only if [entity.node] is within FOV (not [entity.move.node]) and [isTouching] will check both of them so in special case when entity's FOV is only 1 node and the player is two nodes away ([player.node]) then player will not be attacked even if his [move.node] is within range of [isTouching] - to fix this, below conditions should be divided into 2 seperate ones.
		
		if not is_invisible then
			if is_hunting and checkFovData(aEn, "entity", plr) and #aEn.item == 0 then
				if aEn:isTouching(plr) then
					agg, def = aEn, plr
					entity.prepareKeys(1)
					break
				elseif aEn.info ~= "ghost" then
					astar.generate(aEn, plr)
				end
			end
			
			if is_exit and aEn.info == "ghost" and aEn:isTouching(plr) then
				agg, def = aEn, plr
				entity.prepareKeys(1)
				break
			end
		end

		aEn:nxtMove()
		aEn:updSpdTbl(true)
			
	end
end



entity.nxtMove = function(this)
--=================================================================================================================================
	local random = math.random
	local dir = {}
	local steady = false

	if this.info ~= "ghost" then
		if #this.path > 0 then
			
			local last = #this.path
			if not node[this.path[last].y][this.path[last].x].entity then

				this.move =	{
							node	= this.path[last],
							g		= 0,
							dx		= 0,	-- this is ONLY needed to determine if entity is moving in the same direction
							dy		= 0,
							t		= 0
							}

				this.move.g = (this.node.x - this.move.node.x) * (this.node.y - this.move.node.y) == 0 and 10 or 14
				this.move.t = this.move.g / this.spd
				this.path[last] = nil	--I can transfer this line into [moveMake] to see whole path (otherwise one node will be missing)
			else
				this.move =	{
							node	=	this.node,
							g		=	this.spd,
							dx		=	0,
							dy		=	0,
							t		=	1
							}
							
			end	
		else
			for dy = -1, 1 do
				for dx = -1, 1 do
					if node[this.node.y + dy][this.node.x + dx].is_walkable and not node[this.node.y + dy][this.node.x + dx].entity then

						dir[#dir + 1] =	{
										node	=	node[this.node.y + dy][this.node.x + dx],
										g		=	dx * dy ~= 0 and 14 or 10,
										dx		=	dx,
										dy		=	dy,
										t		=	0
										}
										
						if this.move.dx == dx and this.move.dy == dy then
							steady = true
							this.move.node = node[this.node.y + dy][this.node.x + dx]
						end
					end
				end
			end
			if #dir == 0 then	-- stay in place, [ghost] cannot move - it's still in [spdTbl] but does notging
			
				this.move =	{
							node	=	this.node,
							g		=	this.spd,
							dx		=	0,
							dy		=	0,
							t		=	1
							}

			elseif	#dir > 0 and not steady then
				this.move = dir[random(#dir)]
				this.move.t = this.move.g / this.spd
			end
		end
		this.move.node.entity = this
		
	else
	
		local dx, dy = 0, 0
		repeat dx = random(-1, 1) until this.node.x + dx >= 1 and this.node.x + dx <= node.width 
		repeat dy = random(-1, 1) until this.node.y + dy >= 1 and this.node.y + dy <= node.height
		this.move =	{
			node	=	node[this.node.y + dy][this.node.x + dx],
			g		=	dx * dy ~= 0 and 14 or 10,
			dx		=	dx,
			dy		=	dy,
			t		=	0
			}
		this.move.t = this.move.g / this.spd
	end
end



entity.prepareKeys = function(items)
--[[===============================================================================================================================
	items	[num] how many items to ask about
		
	this function only prepares the keys and sets [gs]
	[gs = write] must always follow this function but it cannot be called from inside if monster is an aggressor: in this case I need to display some bubbles and let the player hit [return] (it wouldn't be possible if [gs]=write were inside of this code) - if player attacks then it's not a problem - his bubbles are displayed while pressing [arrows] so pressing [enter] will trigger [attack] and [gs = write]
---------------------------------------------------------------------------------------------------------------------------------]]
	remTime = ansTime
	tTo = def.node	-- for other functions like [update]
	local random = math.random
	
	entity[1].desc = "just a text to block player movement when moster attacks and gs is changed to pause"
	if agg.info == "monster" or agg.info == "ghost" then playSound("attack") end

	local giveTbl = {}
	if #def.item == 0 then
		giveTbl = copyTable(item.putIntoMemory())
		items = level
		agg.desc = agg.info
		agg.info = "final"
	else
		giveTbl = copyTable(def.item)
	end
	
	for i = 1, items do
		local rnd = random(#giveTbl)
		itemsList[i] = giveTbl[rnd]
		table.remove(giveTbl, rnd)
		if random(0, 1) == 1 then itemsList[i].data[1], itemsList[i].data[2] = itemsList[i].data[2], itemsList[i].data[1] end
	end
	
	if agg.info == "monster" or agg.info == "ghost" or agg.info == "final" then
		gs = "pause"
	else
		gs = "write"
		love.audio.play(sound.ansTime[1])
	end
end



entity.itemTransfer = function(give)
--[[===============================================================================================================================
	true - defender will give item away
	false - no item is being transfered
	
	it will create Boss if player has sufficient keys

	item taken from player by boss/spell must be put back on map
---------------------------------------------------------------------------------------------------------------------------------]]
	local random = math.random
	local aIt = itemsList[#itemsList]
	local plr = entity[1]
	local skip = false
	local x = plr.xT + node.size / 2
	local y = plr.yT + node.size / 2
	love.audio.stop(sound.ansTime[1])

	if give then	-- defender gives an item away
		if agg.info == "player" then
			aIt.entity = agg
			agg.item[#agg.item + 1] = aIt
			agg.range = agg.range + 1
			def.autoPickCh = random(50, 100)
			def.graphic = 18
			def:teleport()
			bubData =	{
						x, y,
						"that was easy", font.cooper[16], "t",
						yellow, black
						}
			gs = "play"
		elseif agg.info == "monster" then
			def.range = def.range - 1
			aIt.entity = agg
			agg.autoPickCh = 0
			agg.item[#agg.item + 1] = aIt
			agg.graphic = 17
			agg:teleport()
			bubData =	{
						x, y,
						"That SOMETHING took my key away !!", font.cooper[16], "t",
						yellow, red
						}
			gs = "play"
		elseif agg.info == "ghost" then
			def.range = def.range - 1
			agg.autoPickCh = 0
			agg:teleport()
			bubData =	{
						x, y,
						"hey !!\nwhere's my key?", font.cooper[16], "t",
						yellow, red
						}
			gs = "play"			
		elseif agg.info == "final" then
			def:die()
		elseif agg.info == "boss" then
			def.range = def.range - 1
			bubData =	{
						x, y,
						"well...\n I need to find more keys", font.cooper[16], "t",
						yellow,  red
						}
			gs = "play"
		elseif agg.info == "spell" then
			def.range = def.range - 1
			bubData =	{
						x, y,
						"oops...", font.cooper[16], "t",
						yellow,  red
						}
			gs = "play"
		end

		if agg.info == "ghost" or agg.info == "boss" or agg.info == "spell" then
			local aNd = {}
			repeat
				aNd = nodeFloor[random(#nodeFloor)]
			until not checkFovData(entity[1], "node", aNd) and #aNd.item == 0 and not aNd.entity
			aIt.entity = nil
			aIt.node = aNd
			aNd.item = {aIt}
		end
		
		for i = 1, #def.item do
			if def.item[i] == aIt then
				table.remove(def.item, i)
				break
			end
		end
		
		spell.spellUpdateList()	
		agg, def = {}, {}
			
	else	-- defender does not give any items
	
		if agg == plr then
			def:teleport()
			bubData =	{
						x, y,
						"maybe next time", font.cooper[16], "t",
						yellow, black
						}
			agg, def = {}, {}
			gs = "play"
		elseif agg.info == "monster" then
			agg:die()
			bubData =	{
						x, y,
						"maybe next time", font.cooper[16], "t",
						yellow, black
						}
			agg, def = {}, {}
			gs = "play"
		elseif agg.info == "ghost" then
			agg:teleport()
			bubData =	{
						x, y,
						"what the %#% was that?", font.cooper[16], "t",
						yellow, black
						}
			agg, def = {}, {}
			gs = "play"

		elseif agg.info == "boss" or agg.info == "spell" or agg.info == "final" then
			
			if agg.info ~= "final" then
				local aNd = {}
				repeat
					aNd = nodeFloor[random(#nodeFloor)]
				until aNd.is_walkable and not checkFovData(entity[1], "node", aNd) and #aNd.item == 0 and not aNd.entity
				aIt.entity = nil
				aIt.node = aNd
				aNd.item = {aIt}
				

				for i = 1, #def.item do
					if def.item[i] == aIt then
						table.remove(def.item, i)
						break
					end
				end
			end
			
			spell.spellUpdateList()		
		
			itemsList[#itemsList] = nil
			if #itemsList == 0 then
				love.audio.stop(sound.ansTime[1])
				if agg.info == "boss" then
					bubData =	{
								agg.xT + node.size / 2, agg.yT + node.size / 2,
								"now the gate is open", font.cooper[16], "t",
								green, black
								}
					is_exit = true
					local rnd
					repeat rnd = random(#nodeFloor) until nodeFloor[rnd].is_walkable --and not nodeFloor(rnd).is_visible
					local aNd = nodeFloor[rnd]
					aNd.info = "hole"
					aNd.graphic = 20
				elseif agg.info == "spell" then
					agg.spell.start()
					agg.spell.remaining = agg.spell.duration
					-- all interferring spells must terminate at once
					for i = 1, #spell do
						if spell[i].remaining == 0 then
							spell[i].remaining = -1
							spell[i].stop()
						end
					end
					bubData =	{
								x, y,
								"I think\nI did it", font.cooper[16], "t",
								yellow, black
								}
				elseif agg.info == "final" then
					agg.info = agg.desc
					agg.desc = ""
					if agg.info == "monster" then
						agg:die()
					else
						agg:teleport()
					end
				end
				
				agg, def = {}, {}
				gs = "play"
			else
				skip = true
				remTime = ansTime
				love.audio.play(sound.ansTime[1])
			end
		end
	end
	if #plr.item >= level and not is_hunting then entity.makeBoss() end
	if not skip then
		plr.desc = ""
		if spdTbl[1].id ~= 1 then entity.moveMake() end
	end
	
	if #plr.item == 0 and hint.noItems == 1 and is_boss then
		bubData	=	{
					(entity[1].node.x - 1) * node.size + node.size / 2, (entity[1].node.y - 1) * node.size + node.size / 2,
					"I have no keys.\n"..
					"If I get attacked now,\n"..
					"in order to survive\n"..
					"I will have to answer\n"..
					"as many questions as\n"..
					"current level is", font.cooper[16], "t",
					white, black
					}
		hint.noItems = 0
	end
end



entity.die = function(this)
--[[===============================================================================================================================
	this - entity to kill
---------------------------------------------------------------------------------------------------------------------------------]]	
	if this.id == 1 then
		gs = "GAME OVER"
		tTo = entity[1].node
	else
		this.info = "ghost"
		this.is_walkable = true
		this.node.entity = nil				-- none of the nodes hold its data anymore, but entity still holds node's data because [entity.node] is not ereased
		this.move.node.entity = nil			-- none of the nodes hold its data anymore, but entity still holds node's data because [entity.node] is not ereased
		this.path = {}
		this.picture = picture[2]
		if this.node.info ~= "hole" then	-- do not obscure [hole] with [R.I.P.]
			this.node.info = "R.I.P."
			this.node.graphic = 21
		end
		playSound("dieMonster")
		this:teleport()
	end
end



entity.teleport = function(this)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	-- playSound("teleport")
	local random = math.random
	local aNd = {}
	repeat
		aNd = nodeFloor[random(#nodeFloor)]
	until not checkFovData(entity[1], "node", aNd) and not aNd.entity

	this.node.entity = nil
	this.move.node.entity = nil
	this.path = {}
	this.node = aNd
	if this.info ~= "ghost" then
		this.node.entity = this
	end
	fov.generate(this)	--check if it works!!!!!!!!!!!!!!!!!!!!!!!!!
	fov.generate(entity[1])	--check if it works!!!!!!!!!!!!!!!!!!!!!!!!!
	this:nxtMove()
	entity.moveMake()
end



entity.isTouching = function(this, that)
--[[===============================================================================================================================
	it only checks if 2 entites are touching
	
	this - entity that is checking (always aEn.node - NEVER aEn.move.node)
	that - target (always check for both nodes)
---------------------------------------------------------------------------------------------------------------------------------]]
	local abs = math.abs

	local dx = abs(this.node.x - that.node.x)
	if dx > 1 then
		dx = abs(this.node.x - that.move.node.x)
		if dx > 1 then
			return false
		end
	end
	
	local dy = abs(this.node.y - that.node.y)
	if dy > 1 then
		dy = abs(this.node.y - that.move.node.y)
		if dy > 1 then
			return false
		end
	end
	
	if this.id == 1 then
		this.move =	{
					node	= this.node,
					g		= this.spd,
					dx		= 0,
					dy		= 0,
					t		= dx * dy ~= 0 and 14 / this.spd or 10 / this.spd
					}
	end
	
	return true
end



entity.pauseReturn = function(key)
--[[===============================================================================================================================
	takes care of [RETURN] when [gs] = pause
---------------------------------------------------------------------------------------------------------------------------------]]
	local plr = entity[1]
	
	if key == "return" then
	
		if def == plr then
	
			gs = "write"
			love.audio.play(sound.ansTime[1])
	

		elseif tTo.entity and tTo.entity.id > 1 and #tTo.entity.item > 0 and plr:isTouching(tTo.entity) then

			if tTo.entity.info == "boss" and not is_exit and #plr.item >= level then
				agg = tTo.entity
				def = plr
				entity.prepareKeys(level)
				plr:updSpdTbl(true)
			elseif tTo.entity.info == "monster" then
				agg = plr
				def = tTo.entity
				entity.prepareKeys(1)
				plr:updSpdTbl(true)
			end
			fov.generate(plr)
		else
		
			gs = "play"

		end
	bubData = {}
	redrawAll()
	end


end



entity.update = function(dt)
--[[===============================================================================================================================
	it is divided into 2 parts:
	1. player movements in [play] and tTo movements in [pause]
	2. bubbles in [pause] + [write] and [key = "return"] actions while in [pause] only --- disaster!!!!! gs = write MUST be changed!!!!!
---------------------------------------------------------------------------------------------------------------------------------]]
	local plr = entity[1]
	local x, y	= 0, 0
	local FS = node.size

	if love.keyboard.isDown("right", "left", "up", "down") then
		bubData = {}
		c, d = c + dt, d + 1
		if c > 0.5 or d == 10 then
			--==================================================planning player's next (future) move
			local dx, dy, g = 0, 0, plr.spd
			if love.keyboard.isDown("right") then dx = 1 end
			if love.keyboard.isDown("left") then dx = -1 end
			if love.keyboard.isDown("down") then dy = 1 end
			if love.keyboard.isDown("up") then dy = -1 end
			g = dx * dy ~= 0 and 14 or 10

			if gs == "play" then
		
				x, y = plr.node.x, plr.node.y
				if not node[y + dy][x + dx].entity and node[y + dy][x + dx].is_walkable then

					plr.move =	{
								node	= node[y + dy][x + dx],
								g		= g,
								dx		= dx,
								dy		= dy,
								t		= g / plr.spd
								}
								
					plr.move.node.entity = plr
				
				else
				
					plr.move =	{
								node	= plr.node,
								g		= plr.spd,
								dx		= 0,
								dy		= 0,
								t		= 1
								}
				end
				--===================== at this point player has already its [move] (future move). Up to now player is first in [spdTbl] but after [updSpdTbl] it will be transferred to proper position inside the table. Then all monsters in front of player will make their future move and new future move will be planed. If their new future move is fatser then player future move then it will be done again before player's. This will stop after player's future move is done (so the new one must be planned - human choice)

				plr:updSpdTbl(true)
				entity.moveMake()
				
				--========================= update true coordinates of entities =====================
				for i = 1, #entity do
					local fx = (entity[i].node.x - 1) * FS
					local fy = (entity[i].node.y - 1) * FS
					local tx = (entity[i].move.node.x - 1) * FS
					local ty = (entity[i].move.node.y - 1) * FS
					local t = entity[i].move.t
					local timerO = entity[i].timer - t
					local timerN = entity[1].timer
					local x = ( timerN - timerO) / t
					entity[i].xT = round(fx + x * (tx - fx))
					entity[i].yT = round(fy + x * (ty - fy))
				end
				
				--============================ generate FOV =======================
				for i = 1, #entity do
					fov.generate(entity[i])
				end
				
				--============================ "countdown" for spells ==================
				for i = 1, #spell do
					if spell[i].remaining > 0 then
						spell[i].action()
						spell[i].remaining = spell[i].remaining - 1
					end
					if spell[i].remaining == 0 then
						spell[i].remaining = -1
						spell[i].stop()
					end					
				end
				
			elseif gs == "pause" and plr.desc == "" then
			
				x, y = tTo.x, tTo.y
				local check = false	-- can only check player's visible nodes
				for i = 1, #plr.fov.node do
					if node[y + dy][x + dx] == plr.fov.node[i] then
						check = true
						break
					end
				end
				if check and node[y + dy][x + dx].is_walkable then tTo = node[y + dy][x + dx] end
			
			end
		end	
	else
		c, d = 0, 0
	end
	
------------------------------------------------ THIS PART IS RESPONSIBLE FOR SOME BUBBLES -------------------------


	local txt		= ""
	local floor 	= math.floor
	
	if gs == "play" then	--====================================================================================== PLAY ========================

		bubDataC = {}
		-- if is_exit then
			-- lvlTime = lvlTime - dt
			-- if lvlTime <= 0 then
				-- gs = "GAME OVER"
			-- end
		-- end
		local bos = entity[#entity]
		if is_hunting and checkFovData(plr, "entity", bos) then
			x = bos.xT + FS / 2
			y = bos.yT + FS / 2
			local txt = ""
			if is_exit then
				txt =	"hurry...\n"..
						floor(lvlTime+1).." sec left"
			elseif #plr.item >= level then
				txt = "we have to talk"
			elseif #plr.item < level then
				txt =	"find more keys\n"..
						"then we'll talk"
			end
			bubData = {x, y, txt, font.cooper[16], "t", transGreen, black}
		end
		
	elseif gs == "pause" then	--====================================================================================== PAUSE ========================

		if tTo.entity then
			local aEn = tTo.entity
			x = aEn.xT + FS / 2
			y = aEn.yT + FS / 2
		
			if #aEn.item > 0 and aEn.id > 1 then
				if plr:isTouching(aEn, 1) and aEn.info == "boss" then
					txt =	"are you ready?\n\n"..
							"[ENTER] - yes\n"..
							"[ARROWS] - no"
				elseif plr:isTouching(aEn, 1) and aEn.info == "monster" then
					txt =	"attack him?\n\n"..
							"[ENTER] - yes\n"..
							"[ARROWS] - no"
				elseif aEn.info == "monster" or aEn.info == "boss" then
					txt = "he is too far"
				end
			elseif #aEn.item == 0 and aEn.id > 1 then
				txt = "this one has no keys"
			elseif aEn.id == 1 then
				txt =	"hey, it's me\n"..
						"I mean... you"
			end
			bubData = {x, y, txt, font.cooper[16], "r"}
		else
			bubData = {}
		end

		if def == plr then
			x = agg.xT + FS / 2
			y = agg.yT + FS / 2
			if #def.item > 0 then
				if agg.info == "monster" or agg.info == "ghost" then
					txt =	"die !!!\n\n"..
							"---> [ENTER] <---"
					bubData = {x, y, txt, font.cooper[16], "t", red, white}
				else
					bubData = {}
				end
			else
				if agg.info == "final" then
					txt =	"you must be very stupid\n"..
							"to wander around\n"..
							"with no keys on you\n\n"..
							"this is gonna be fun\n"..
							"---> [ENTER] <---"
					bubData = {x, y, txt, font.cooper[16], "t", red, white}
				else
					bubData = {}
				end
			end
			redrawAll()
		end

	elseif gs == "write" then	--====================================================================================== WRITE ========================

		local aIt = itemsList[#itemsList]
		txt = aIt.data[2].."\n"..txtOut
		bubData = {}
		remTime = remTime - dt
		bubDataC = {agg.picture, 2, txt, font.show[34]}
		if txtOut == aIt.data[1] or remTime <=0 then
			bubDataC = {}
			if remTime > 0 then	-- means that player answered corectly
				if def == plr then
					entity.itemTransfer(false)
				else
					entity.itemTransfer(true)
				end
			else	-- time is up so the answer is wrong
				if def == plr then
					entity.itemTransfer(true)
				else
					entity.itemTransfer(false)
				end
			end
			txtOut = ""
		end
		redrawAll()
	
	elseif gs == "GAME OVER" then	--====================================================================================== GAME OVER ========================
		bubData = {}
		bubDataC = {plr.picture, 2, "GAME OVER\n---> [ENTER] <---", font.show[34]}
		is_showVisited = true
		is_showFov = true
		redrawAll()
	
	end
	
	--================================================== REDRAW ALL ===============================================================================
	if ((gs == "play" or gs == "pause") and (c > 0.5 or d == 10) and love.keyboard.isDown("up", "down", "left", "right")) then
		redrawAll()
	end
end


return entity