local fov = {}

function fov.generate(aEn)
	local abs = math.abs

	aEn.node.is_visible = false
	aEn.fov = {entity = {}, item = {}, node = {}}

	-- include aEn's node in its own FOV
	aEn.fov.node = {aEn.node, 0}
	-- include "itself" in its own FOV
	aEn.fov.entity = {aEn, 0}
	
	if aEn.info ~= "ghost" then
		local o = 	{
					{	Y_STEP = -1,	X_STEP = -1	},
					{	Y_STEP = -1,	X_STEP = 1	},
					{	Y_STEP = -1,	X_STEP = 1	},
					{	Y_STEP = 1,		X_STEP = 1	},
					{	Y_STEP = 1,		X_STEP = 1	},
					{	Y_STEP = 1,		X_STEP = -1	},
					{	Y_STEP = 1,		X_STEP = -1	},
					{	Y_STEP = -1,	X_STEP = -1	}
					}		
					
		for v = 1, 8 do

			if v == 3 or v == 5 or v == 7 then	--swap every 2 octanes - 1,2 = 5,6 and 3,4 = 7,8
			
				aEn.node.x, aEn.node.y = aEn.node.y, aEn.node.x
				o[v].Y_STEP, o[v].X_STEP = o[v].X_STEP, o[v].Y_STEP
				node.width, node.height = node.height, node.width
				
			end
			fov.newScan(aEn, v, aEn.node.y, o[v].Y_STEP, o[v].X_STEP, 1, 0)

		end
		aEn.node.x, aEn.node.y = aEn.node.y, aEn.node.x
		node.width, node.height = node.height, node.width

		for i = 1, #aEn.fov.entity, 2 do
			aEn.fov.entity[i].is_visible = false
		end
		for i = 1, #aEn.fov.item, 2 do
			aEn.fov.item[i].is_visible = false
		end
		for i = 1, #aEn.fov.node, 2 do
			aEn.fov.node[i].is_visible = false
		end
	end
end

-- a/n/p Slp/Nd = actual/next/previous slope/node

function fov.newScan(aEn, oct, start, Y_STEP, X_STEP, sSlp, eSlp)

	local abs = math.abs
	local sqrt = math.sqrt
	local msg = "set"
	local x, y
	local ss, es = sSlp, eSlp
	for y = start + Y_STEP, aEn.node.y + node.height * Y_STEP, Y_STEP do	--node.height is enough - when @ is at 1 then 1+node.height gives oposite limit

		if node[y] then	--this is safe but CANNOT BE DONE WITH "X"

			msg = "set"
			for x = aEn.node.x + (abs(aEn.node.y - y)) * X_STEP, aEn.node.x, X_STEP * (-1) do
					
				if x > 1 and x < node.width then	-- cannot be <= / >= because there must be a room for pNd - but anyway this is working I think because x and y swaps and other octane is highlighting them

					local distX = aEn.node.x - x
					local distY = aEn.node.y - y
					local dist = sqrt(distX * distX + distY * distY)	-- MUST ADD DIRECTION AS WELL !!!!!!!!!!!!!!!
					
					if dist < aEn.range then

						local aSlp = abs(distX / distY)
						local aNd = node[y][x]
						local pNd = node[y][x + X_STEP]	--horizontaly away
						local xNd = node[y - Y_STEP][x + X_STEP]	--vertically closer to the source and horizontally away
						local dNd = node[y - Y_STEP][x]	--verticaly closer
						if oct == 3 or oct == 4 or oct == 7 or oct == 8 then

							aNd = node[x][y]
							pNd = node[x + X_STEP][y]
							xNd = node[x + X_STEP][y - Y_STEP]
							dNd = node[x][y - Y_STEP]
							
						end
						if (aSlp <= sSlp) and (aSlp >= eSlp) then

							local pSlp = abs((aEn.node.x - (x + X_STEP)) / distY)					
							if msg == "set" then msg = nil end
							
							if aNd.is_walkable ~= pNd.is_walkable then
								if aNd.is_walkable then
								
									msg = "start"
									ss = aSlp
									if pSlp <= 1 then
										
										if not pNd.is_visible then
											aEn.fov.node[#aEn.fov.node + 1] = pNd
											aEn.fov.node[#aEn.fov.node + 1] = dist
											pNd.is_visible = true
										end
										if aEn.id == 1 then	-- this must be expanded to all entities
											if not pNd.is_visited then
												aEn.visited[#aEn.visited + 1] = pNd
												pNd.is_visited = true
											end
										end
										
									end
									
								else
								
									msg = "end"
									fov.newScan(aEn, oct, y, Y_STEP, X_STEP, ss, pSlp)	--using previous slope because active one is a blocker
								
								end
								
							end
							local nSlp = ((aEn.node.x - (x - X_STEP)) / distY) * Y_STEP * X_STEP	--uwzgledniny znak oktany jesli nSlp przejdzie 0
							if nSlp < eSlp and msg == "start" and aNd.is_walkable then
							
								fov.newScan(aEn, oct, y, Y_STEP, X_STEP, ss, eSlp)
								
							end
							if not aNd.is_walkable then
								
								msg = "solid"
							
							end
							
--==========================================================================================

							if not aNd.is_visible then
								aEn.fov.node[#aEn.fov.node + 1] = aNd
								aEn.fov.node[#aEn.fov.node + 1] = dist
								aNd.is_visible = true
							end
							if aEn.id == 1 then
								if not aNd.is_visited then
									aEn.visited[#aEn.visited + 1] = aNd
									aNd.is_visited = true
								end
							end
							if not aNd.is_walkable and not pNd.is_walkable and not xNd.is_walkable and dNd.is_walkable and pSlp <= 1 then
								if not pNd.is_visible then
									aEn.fov.node[#aEn.fov.node + 1] = pNd
									aEn.fov.node[#aEn.fov.node + 1] = dist
									pNd.is_visible = true
								end
								if aEn.id == 1 then
									if not pNd.is_visited then
										aEn.visited[#aEn.visited + 1] = pNd
										pNd.is_visited = true
									end
								end
							end
							if aNd.entity and not aNd.entity.is_walkable then
								if not aNd.entity.is_visible and abs(aNd.entity.xT / node.size - (aNd.x - 1)) <= 0.5 and abs(aNd.entity.yT / node.size - (aNd.y - 1)) <= 0.5 then
									aEn.fov.entity[#aEn.fov.entity + 1] = aNd.entity
									aEn.fov.entity[#aEn.fov.entity + 1] = dist
									aNd.entity.is_visible = true
								end
							end
							if #aNd.item > 0 then
								if not aNd.item[1].is_visible then
									aEn.fov.item[#aEn.fov.item + 1] = aNd.item[1]
									aEn.fov.item[#aEn.fov.item + 1] = dist
									aNd.item[1].is_visible = true
								end
							end
						end	--check if xy are within slopes
					end --check if in range 
				end	--check if x is on the node
			end	--x loop (inner)
		end	--checkif y is on the node
		if msg then break end
	end	--y loop (outer)
end

return fov