agg, def = {}, {}

nodeFloor = {}	--table of walkable nodes
gs = "play"	--game state
MON_NO = 10	--maximum number of monsters


red	= {255, 0, 0, 255}
yellow = {255, 255, 0, 255}
white = {255, 255, 255, 255}
black = {0, 0, 0, 255}
transGreen = {0, 255, 0, 120}
green = {0, 255, 0, 255}


spellTime = 0
ansTime = 5
lvlTime = 30
remTime = ansTime


level = 2
tTo = nil
txtOut = ""


is_showAll = false
is_showFov = false
is_showVisited = false
is_showGhosts = false
is_invisible = false
is_hunting = false
is_exit = false

hint = {key = 1, pause = 1, spell = 1, winerWithRed = 1, winnerWithWhite = 1, looserWithRed = 1, looserWithWhite = 1, noItems = 1}

bgSnd = ""

local random = math.random
math.randomseed(os.time())


node	=	{
			bspMax	= random(2,7),
			height	= 50,
			roomMin	= random(1,7),
			roomMax	= random(20,40),
			size	= 12,	-- node actual size - height and width
			width	= 50,
			wShift	= 0
			}

			
quads = {}
tileset = love.graphics.newImage("data/pic/pic_"..node.size..".png")
tileW, tileH = node.size, node.size
local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
local c = 1
for i = 0, 3 do
	for j = 0, 7 do
		quads[c] = love.graphics.newQuad(j * node.size, i * node.size, tileW, tileH, tilesetW, tilesetH)
		c = c + 1
	end
end


-- dict	=	"data/text/jap_eng.txt"
dict	=	"data/text/pol_eng.txt"


font	=	{
			cooper	=	{
						[12] = love.graphics.newFont("f_coopbl.ttf", 12),
						[16] = love.graphics.newFont("f_coopbl.ttf", 16)
						},
			show	=	{
						[34] = love.graphics.newFont("f_showG.ttf", 34),
						[90] = love.graphics.newFont("f_showG.ttf", 90)
						}
			}


picture =	{
			love.graphics.newImage("data/pic/monster_01.png"),	--player
			love.graphics.newImage("data/pic/monster_02.png"),	--ghost
			love.graphics.newImage("data/pic/monster_03.png"),	--boss - not done yet
			love.graphics.newImage("data/pic/monster_04.png"),	--monster
			love.graphics.newImage("data/pic/monster_05.png")	--monster
			}
			
			
			
sound	= 	{
			ansTime		= 	{love.audio.newSource("data/sound/ansTime.ogg", "static")},
			attack		=	{
							love.audio.newSource("data/sound/attack1.ogg", "static"),
							love.audio.newSource("data/sound/attack2.ogg", "static")
							},
			dieMonster	= 	{love.audio.newSource("data/sound/dieMonster.wav", "static")},
			exitShowUp	= 	{love.audio.newSource("data/sound/exitShowUp.wav", "static")},
			takeItem	= 	{love.audio.newSource("data/sound/itemget.wav", "static")},
			teleport	= 	{love.audio.newSource("data/sound/teleport.ogg", "static")},
			walk		= 	{love.audio.newSource("data/sound/walk1.ogg", "static")}
			}
		

-- music	= 	{
			-- love.audio.newSource("data/sound/gomixit_bells.ogg", "stream"),
			-- love.audio.newSource("data/sound/gomixit_szanty.ogg", "stream")
			-- }

		
		
function makeLevel()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	-- if bgSnd ~= "" then love.audio.stop(bgSnd) end
	-- bgSnd = music[random(#music)]
	-- bgSnd:setLooping(true)
	-- love.audio.play(bgSnd)
	
	is_showAll = false
	is_showFov = false
	is_showVisited = false
	is_showGhosts = false
	is_invisible = false
	is_hunting = false
	is_exit = false
	is_exit = false
	is_hunting = false

	bubData = {}
	bubDataC = {}		
	
	for i = 1, #entity do entity[i] = nil end
	for i = 1, #item do item[i] = nil end
	for i = 1, #spell do
		spell[i].is_avail = false
		spell[i].remaining = 0
	end
	
	bsp.generate()
	astar.preset()
	item:putOnMonster(entity:putOnMap(item:putOnMap()))
	redrawAll()
end



letMeWrite = function(key, unicode)
--[[===============================================================================================================================
	takes each printable keystroke and creates [txtOut]
---------------------------------------------------------------------------------------------------------------------------------]]	
	if key == "backspace" then txtOut = string.sub(txtOut, 1, #txtOut - 1)
	elseif unicode > 31 and unicode < 127 then txtOut = txtOut..string.char(unicode)
	end
	
end



playSound = function(sfx)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local random = math.random
	if #sound[sfx] > 1 then
		sfx = sound[sfx][random(#sound[sfx])]
	else
		sfx = sound[sfx][1]
	end
	love.audio.stop(sfx)
	love.audio.play(sfx)

end


	
function round(what, shift)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	shift = 10 ^ (shift or 0)
	return math.floor(what * shift + 0.5 ) / shift
end



function copyTable(from)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local to = {}
	for i = 1, #from do
		to[#to + 1] = from[i]
	end
	return to
end


checkFovData = function(where, data, what)
--[[===============================================================================================================================
checks if a node/item/entity is whitin entity's FOV:
checkFovData(plr, "node", aNd) - looks for [aNd] in plr's [fov.node]
if it finds it then returns distance to it

to do:
it should return distance and direction (must change FOV.lua for this)
---------------------------------------------------------------------------------------------------------------------------------]]
	data = where.fov[data]
	for i = 1, #data, 2 do
		if data[i] == what then
			return data[i + 1]
		end
	end
	return nil
end



dimFovData = function(what, dist)
--[[===============================================================================================================================
adjust brightness of entity / item / node
---------------------------------------------------------------------------------------------------------------------------------]]
	local bright = 255
	if dist > 0.85 * what.range then
		bright = 80
	elseif dist > 0.7 * what.range then
		bright = 160
	end
	return bright
end



drawQuads = function()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local FS = node.size
	love.graphics.setColor(white)

	--================================================== draws visited nodes =================================
	if is_showVisited then
		love.graphics.setColor(255, 255, 255, 50)
		for i = 1, #entity[1].visited do
			if entity[1].visited[i].info == "hole" or entity[1].visited[i].info == "R.I.P." then -- do not display RIP or hole
				love.graphics.drawq(tileset, quads[9], (entity[1].visited[i].x - 1) * FS, (entity[1].visited[i].y - 1) * FS)
			else
				love.graphics.drawq(tileset, quads[entity[1].visited[i].graphic], (entity[1].visited[i].x - 1) * FS, (entity[1].visited[i].y - 1) * FS)
			end
		end
	end
	
	--================================================== draws ghosts =================================
	if is_showGhosts then
		love.graphics.setColor(white)
		for i = 2, #entity do
			if entity[i].info == "ghost" then
				love.graphics.print("G", entity[i].xT, entity[i].yT)
			end
		end
	end
	
	--================================================== shows ALL or draws FOVs (in that order: nodes, items, entities) =================================
	if is_showAll then
		for y = 1, node.height do
			for x = 1, node.width do
				if node[y][x].info ~= "void" then
					local q = quads[node[y][x].graphic]
					local xx = (x - 1) * FS
					local yy = (y - 1) * FS
					love.graphics.drawq(tileset, q, xx, yy)
				end
			end
		end
		for i = 1, #item do
			if item[i].node then
				local q = quads[item[i].graphic]
				local x = (item[i].node.x - 1) * FS
				local y = (item[i].node.y - 1) * FS
				love.graphics.drawq(tileset, q, x, y)
			end
		end
		for i = 1, #entity do
			if not entity[i].is_walkable then
				local q = quads[entity[i].graphic]
				local x = (entity[i].node.x - 1) * FS
				local y = (entity[i].node.y - 1) * FS
				love.graphics.drawq(tileset, q, x, y)
			end
		end
	else
		for i = 1, #entity do
			if entity[i].info ~= "ghost" then
				for j = 1, 3 do
					local aFov = entity[i].fov.node
					if j == 2 then
						aFov = entity[i].fov.item
					elseif j == 3 then
						aFov = entity[i].fov.entity
					end
					
					for k = 1, #aFov, 2 do
						local q = quads[aFov[k].graphic]
						local x, y, a1, b1, a2, b2 = 0, 0, 0, 0, 0, 0
					
						if j == 1 then	--nodes
							x = (aFov[k].x - 1) * FS
							y = (aFov[k].y - 1) * FS
						elseif j == 2 then	--items
							x = (aFov[k].node.x - 1) * FS
							y = (aFov[k].node.y - 1) * FS
						elseif j == 3 then	--entities
							x = aFov[k].xT
							y = aFov[k].yT
						end
						
						if j == 3 then
							local c1 = aFov[k].xT + FS / 2 + FS / 2 * aFov[k].move.dx
							local d1 = aFov[k].yT + FS / 2 + FS / 2 * aFov[k].move.dy
							love.graphics.setColor(0, 0, 255, 255)
							love.graphics.circle("fill",c1, d1, 4, 4)
						end
						
						love.graphics.setColor(255, 255, 255, dimFovData(entity[i], aFov[k + 1]))
						if j == 3 and aFov[k].info == "player" and is_invisible then
							love.graphics.setColor(255, 255, 255, 80)
						end
						love.graphics.drawq(tileset, q, x, y)
					end
				end
			end
			if not is_showFov then break end
		end
	end
	
	--================================================== draws player's path (find boss / exit)=================================
	if #entity[1].path > 0 then
		love.graphics.setColor(white)
		for i = 1, #entity[1].path do
			if checkFovData(entity[1], "node", entity[1].path[i]) then
				local q = quads[23]
				local x = (entity[1].path[i].x - 1) * FS
				local y = (entity[1].path[i].y - 1) * FS
				-- love.graphics.setColor(255, 255, 255, dimFovData(entity[1], entity[1].path[i]))
				love.graphics.drawq(tileset, q, x, y)
			end
		end
	end
	
	--================================================== draws recangle in pause mode ======================================
	if gs == "pause" then
		local x = (tTo.x - 1) * FS
		local y = (tTo.y - 1) * FS
		love.graphics.setColor(red)
		love.graphics.rectangle("line", x, y, FS, FS)
	end
	
	--================================================== draws bubbles ===============================================
	if #bubData > 0 then bubble(unpack(bubData)) end
	if #bubDataC > 0 then bubbleC(unpack(bubDataC)) end

end



bubble = function(x, y, txt, font, style, bkg, frg, brd)
--[[===============================================================================================================================
	TO dO
	ALL !!!!!!!!!!!!!!!
---------------------------------------------------------------------------------------------------------------------------------]]
	x = x or 0
	y = y or 0
	txt = txt or "you need to write something"
	style = style or "t"	-- [t] - with triangle in the corner, [r] - just rectangle
	bkg = bkg or {255, 255, 255, 150}
	frg = frg or {0, 0, 0, 255}
	brd = brd or frg
	
	local fontH = font:getHeight()
	local fontW = font:getWidth("X")

	local function mySplit(txt)
		local len, lines = 0, 1
		repeat
			local div = string.find(txt, "\n")
			if div then
				if #string.sub(txt, 1, div - 1) > len then
					len = #string.sub(txt, 1, div - 1)
				end
				lines = lines + 1
				txt = string.sub(txt, div + 1, #txt)
			end
		until not div
		len = #txt > len and #txt or len
		return #txt > len and #txt or len, lines
	end
	
	local len, lines = mySplit(txt)
	local w = font:getWidth(string.rep("X", len))

	local boxH = fontH * lines + fontH	-- only half of fontH is added to top and to bottom
	local boxW = w + 2*fontW	-- and fontW is added from each side

	local dir = {1, 1}
	local a, b = x + fontW, y + fontH
	local FS = node.size
	if x + FS / 2 + boxW + fontW > love.graphics.getWidth() then
		dir[1] = -1
		a = x - boxW - fontW
	end
	if y + FS / 2 + boxH + fontH > love.graphics.getHeight() then
		dir[2] = -1
		b = y - boxH - fontH
	end

	local x1 = x + fontW * dir[1] * 2
	local y1 = y + fontH * dir[2]
	local x2 = x + (boxW + fontW) * dir[1]
	local y2 = y1
	local x3 = x2
	local y3 = y + (boxH + fontH) * dir[2]
	local x4 = x + fontW * dir[1]
	local y4 = y3
	local x5 = x4
	local y5 = y + fontH * dir[2] * 2

	love.graphics.setLineWidth(1)
	love.graphics.setColor(bkg)
	if style == "r" then
		love.graphics.rectangle("fill", a, b, boxW, boxH)
	else
		love.graphics.polygon("fill", x1,y1, x2,y2, x3,y3, x4,y4, x5,y5)
		love.graphics.triangle("fill", x, y, x1, y1, x5, y5)
	end

	love.graphics.setColor(frg)
	love.graphics.setFont(font)
	love.graphics.printf(txt, a + fontW, b + math.floor(fontH / 2), w + 1, "center")

	if style == "r" then
		love.graphics.setColor(brd)
		love.graphics.rectangle("line", a, b, boxW, boxH)
	else
		love.graphics.setColor(brd)
		love.graphics.polygon("line", x, y, x1, y1, x2, y2, x3, y3, x4, y4, x5, y5)
	end
	love.graphics.setColor(255, 255, 255, 255)
end



bubbleC = function(pic, lines, txt, FONT)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local fontH = FONT:getHeight()
	local winH = love.graphics.getHeight()
	local winW = love.graphics.getWidth()
	local picH = pic:getHeight()
	local picW = pic:getWidth()
	local picX = 16
	local picY = (winH / 2) - (picH / 2)
	-- local boxW = winW
	local boxW = 600
	local boxH = lines * fontH
	local boxY = (winH / 2) - (fontH * lines) / 2

	love.graphics.setColor(black)
	love.graphics.rectangle("fill", 0, boxY, boxW, boxH)
	love.graphics.setColor(white)
	love.graphics.rectangle("line", -1, boxY, boxW, boxH)
	love.graphics.setLineWidth(2)
	love.graphics.rectangle("line", picX-1, picY-1, picW+2, picH+2)
	love.graphics.setLineWidth(1)

	love.graphics.setColor(white)
	love.graphics.setFont(FONT)
	love.graphics.printf(txt, 0, boxY, boxW+picX+picW, "center")
	love.graphics.printf(round(remTime), winW-250, 200, picW+2, "center")
	
	love.graphics.setColor(white)
	love.graphics.draw(pic, picX, picY)
end
