local menu = {}

local data = 	{
				{ title = "bsp",			minV = 0,			maxV = 30,			val = node.bspMax	},
				{ title = "room min",		minV = 1,			maxV = node.roomMax,	val = node.roomMin	},
				{ title = "room max",		minV = node.roomMin,	maxV = 30,			val = node.roomMax	},
				{ title = "wall distance",	minV = 0,			maxV = 5,			val = node.wShift	},
				{ title = "monsters",		minV = 0,			maxV = 100,			val = MON_NO		},
				{ title = "answer time",	minV = 2,			maxV = 20,			val = ansTime		}
				}

local lineNo = 1

function menu.keyPressed(key)
	if key == "down" and lineNo < #data then
		lineNo = lineNo + 1
	end
	if key == "up" and lineNo > 1 then
		lineNo = lineNo - 1
	end
	if key == "left" and data[lineNo].val > data[lineNo].minV then
		data[lineNo].val = data[lineNo].val - 1
	end
	if key == "right" and data[lineNo].val < data[lineNo].maxV then
		data[lineNo].val = data[lineNo].val + 1
	end
	node.bspMax = data[1].val
	node.roomMin = data[2].val
	node.roomMax = data[3].val
	node.wShift = data[4].val
	MON_NO = data[5].val
	ansTime = data[6].val
	remTime = ansTime
	data[2].maxV = node.roomMax
	data[3].minV = node.roomMin
end


function menu.draw()
	love.graphics.setFont(font.libera[FS])
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.line(599, 0, 600, 600)
	love.graphics.line(599, 84, 800, 84)

	for i = 1, #data do
		local v = data[i]
		if i == lineNo then
			love.graphics.setColor(255, 0, 0, 255)
		else
			love.graphics.setColor(255, 255, 255, 255)
		end
		if gs == "play" or gs == "talk" or gs == "write" then
			love.graphics.setColor(255, 255, 255, 255)
		end
		love.graphics.print(v.title.." "..v.minV.."-"..v.maxV..": "..v.val, 605, (i - 1) * FS + i + 2)
	end

	
	-- for i = 1, #entity do
		-- local aEn = entity[i]
		-- if #aEn.path > 0 then
			-- love.graphics.print(aEn.id.." - "..aEn.node.x.."/"..aEn.node.y.."   "..aEn.path[#aEn.path].x.."/"..aEn.path[#aEn.path].y.."   "..aEn.timer, 	50*FS,	300+FS*i)
		-- end
	-- end

	
	love.graphics.print("game state: "..gs, 	605,	280)
	love.graphics.print("     level: "..level,	605,	400)
	love.graphics.print("     score: "..score,	605,	420)

	-- player.drawBubble(600, 500, "text buble by iemfi", fontDeja)	
end

return menu