local lineNo = 1

local spell =	{
				{----------------------------------------------------------
				cost		=	1,
				duration	=	1,
				is_avail	=	false,
				name		=	"destroy a wall",
				remaining	=	-1,
				toTerminate	=	{
								},
				start		=	function()
									local direction = {}
									local random = math.random
									for dy = -1, 1 do
										for dx = -1, 1 do
											local x = entity[1].node.x + dx 
											local y = entity[1].node.y + dy
											if node[y][x].info == "wall" and node[y][x].desc ~= "limit" then
												direction[#direction + 1] = node[y][x]
											end
										end
									end
									if #direction > 0 then
										local aNd = direction[random(#direction)]
										aNd.info = "floor"
										aNd.graphic = random(9, 16)
										aNd.is_walkable = true
										nodeFloor[#nodeFloor + 1] = aNd
										for dy = -1, 1 do
											for dx = -1, 1 do
												local x = aNd.x + dx 
												local y = aNd.y + dy
												if node[y][x].info == "void" then
													node[y][x].info = "wall"
													node[y][x].graphic = random(1, 8)
												end
											end
										end
									end
									fov.generate(entity[1])
									-- if #direction == 0 then
										-- bubData	=	{
													-- (entity[1].node.x - 1) * node.size + node.size / 2, (entity[1].node.y - 1) * node.size + node.size / 2,
													-- "no walls\nnearby", font.cooper[16], "t",
													-- white, black
													-- }
									-- end
								end,
				action		=	function()
								end,
				stop		=	function()
								end
				},
				{----------------------------------------------------------
				cost		=	1,
				duration	=	200,
				is_avail	=	false,
				name		=	"show visited",
				remaining	=	-1,
				toTerminate	=	{
								"show all"
								},
				start		=	function()
									for i = 1, #spell do
										if spell[i].name == "show all" then
											spell[i].remaining = 0
										end
									end
									is_showVisited = true
								end,
				action		=	function()
								end,
				stop		=	function()
									is_showVisited = false
								end
				},
				{----------------------------------------------------------
				cost		=	1,
				duration	=	20,
				is_avail	=	false,
				name		=	"show ghosts",
				remaining	=	-1,
				toTerminate	=	{
								},
				start		=	function()
									is_showGhosts = true
								end,
				action		=	function()
								end,
				stop		=	function() 
									is_showGhosts = false
								end
				},
				{----------------------------------------------------------
				cost		=	2,
				duration	=	20,
				is_avail	=	false,
				name		=	"show FOV",
				remaining	=	-1,
				toTerminate	=	{
								"show all"
								},
				start		=	function()
									for i = 1, #spell do
										if spell[i].name == "show all" then
											spell[i].remaining = 0
										end
									end
									is_showFov = true
								end,
				action		=	function()
								end,
				stop		=	function()
									is_showFov = false
								end
				},
				{----------------------------------------------------------
				cost		=	3,
				duration	=	20,
				is_avail	=	false,
				name		=	"invisible",
				remaining	=	-1,
				toTerminate	=	{
								},
				start		=	function()
									for i = 2, #entity do
										if #entity[i].path > 0 then
											entity[i].path = {}
										end
									end
									is_invisible = true
								end,
				action		=	function()
								end,
				stop		=	function()
									is_invisible = false
								end
				},
				{----------------------------------------------------------
				cost		=	3,
				duration	=	40,
				is_avail	=	false,
				name		=	"find boss",
				remaining	=	-1,
				toTerminate	=	{
								"find exit"
								},
				start		=	function()
									for i = 1, #spell do
										if spell[i].name == "find exit" then
											spell[i].remaining = 0
										end
									end
								end,
				action		=	function()
									if is_hunting then
										astar.generate(entity[1], entity[#entity], false)
									end
								end,
				stop		=	function()
									entity[1].path = {}
								end
				},
				{----------------------------------------------------------
				cost		=	3,
				duration	=	40,
				is_avail	=	false,
				name		=	"find exit",
				remaining	=	-1,
				toTerminate	=	{
								"find boss"
								},
				start		=	function()
									for i = 1, #spell do
										if spell[i].name == "find boss" then
											spell[i].remaining = 0
										end
									end
								end,
				action		=	function()
									local exitNd = {}
									if is_exit then
										for i = 1, #nodeFloor do
											if nodeFloor[i].info == "hole" then
												exitNd = nodeFloor[i]
											break
											end
										end
										astar.generate(entity[1], exitNd, true)
									end
								end,
				stop		=	function()
									entity[1].path = {}
								end
				},
				{----------------------------------------------------------
				cost		=	4,
				duration	=	200,
				is_avail	=	false,
				name		=	"show all",
				remaining	=	-1,	-- now its [stop] won't be non-stop executed in [entity.update]
				toTerminate	=	{
								"show FOV",
								"show visited"
								},
				-- start		=	function()
									-- for i = 1, #spell[1].toTerminate do
										-- for j = 1, #spell do
											-- if spell[j].name == spell[1].toTerminate[i] then
												-- spell[j].remaining = 0
											-- end
										-- end
									-- end
									-- is_showAll = true
								-- end,
				start		=	function()
									for i = 1, #spell do
										if spell[i].name == "show FOV" then
											spell[i].remaining = 0
										end
										if spell[i].name == "show visited" then
											spell[i].remaining = 0
										end
									end
									is_showAll = true
								end,
				action		=	function()
								end,
				stop		=	function()
									is_showAll = false
								end
				},

				}


				
spell.spellUpdateList = function()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	for i = 1, #spell do
		if spell[i].cost <= #entity[1].item then
			spell[i].is_avail = true
		end
	end
	for i = 1, #spell do
		if spell[i].cost > #entity[1].item then
				spell[i].is_avail = false
		end
	end
end



function spell.keyPressed(key)
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	local hh = 0
	for i = 1, #spell do
		if spell[i].is_avail then hh = hh + 1 end
	end
	if key == "down" and lineNo < hh then
		lineNo = lineNo + 1
	elseif key == "up" and lineNo > 1 then
		lineNo = lineNo - 1
	elseif key == "return" then
		agg = {info = "spell", picture = picture[1], spell = spell[lineNo]}
		def = entity[1]
		entity.prepareKeys(spell[lineNo].cost)
	end
	redrawAll()
end



function spell.draw()
--[[===============================================================================================================================
---------------------------------------------------------------------------------------------------------------------------------]]
	love.graphics.setFont(font.cooper[16])
	love.graphics.setColor(255, 255, 255, 100)
	local fontH = font.cooper[16]:getHeight()

	if gs == "spell" then
		love.graphics.print("available", 609, 150)
		love.graphics.print("cost", 749, 150)
		love.graphics.line(599, 150 + fontH, 799, 150 + fontH)
		love.graphics.line(740, 150, 740, 390)

		for i = 1, #spell do
			if i == lineNo then
				love.graphics.setColor(black)
				love.graphics.rectangle("fill", 400, 150 + i * fontH, 199, 120)

				love.graphics.setColor(white)
				love.graphics.rectangle("line", 400, 150 + i * fontH, 199, 120)
				love.graphics.line(400, 150 + (i + 1) * fontH, 599, 150 + (i + 1) * fontH)

				love.graphics.print("spells to terminate:", 405, 150 + i * fontH)
				for j = 1, #spell[i].toTerminate do
					love.graphics.print(spell[i].toTerminate[j], 405, 150 + (i + j) * fontH)
				end
			else
				love.graphics.setColor(255, 255, 255, 100)
			end
			if spell[i].is_avail then
				love.graphics.print(spell[i].name, 609, 150 + i * fontH)
				love.graphics.print(spell[i].cost, 749, 150 + i * fontH)
			end
		end
	end
end

return spell